#!/bin/sh
# <volume (0..0x7fff, 0x4000=0dB)>"
VOL=0x400

# define environment variables for DUA_PARAM_xx (hex), UT_xx, UE_xx
# setUTUE.sh has been created on host by (cd tools/dua && source mkSetUTUE)
. /css/setUTUE.sh


tone_init()
{
dua <<  HEREDOC
        set unit        {UT_WBHF,0} DUA_PARAM_UMT_EXEC_GEN UT_WBHF_MODE_D_CLASS
                        $UT_WBHF,0
                        $DUA_ANY
                        $DUA_PARAM_UMT_EXEC_GEN
                        $UT_WBHF_MODE_D_CLASS
        quit
HEREDOC

}


tone_play()
{
    ((a=$1*16384))
    ((f=$a/1000))
    dua <<  HEREDOC
        Melody          {UT_WBHF,0} UE_IPI
                        $UT_WBHF,0
                        $UE_IPI

        play            {UT_WBHF,0} UE_IPI
                        $UT_WBHF,0
                        $UE_IPI
                        $f
                        ${VOL}
       quit
HEREDOC

}

tone_stop()
{
    dua << HEREDOC
        Melody          {UT_WBHF,0} UE_IPI
                        $UT_WBHF,0
                        $UE_IPI
        quit
HEREDOC
}

sleep_ms()
{
    usleep $(($1*1000))
}

melody_play()
{
    tone_play 300
    sleep_ms 500
    tone_play 600
    sleep_ms 500
    tone_play 900
    sleep_ms 500
}


startup_melody()
{
    /css/dua_init.sh
    tone_init
    melody_play
    tone_stop
}

startup_wav()
{
    if [ ! -e $1 ]; then
	echo "File $1 not exist!"
	exit 1
    fi
    nohup alsa_test 2 0 &>/dev/zero &
    sleep 1
    aplay -c 1 -D CssPlayback $1
    killall alsa_test
}

record_wav()
{
    nohup alsa_test 0 0 &>/dev/zero &
    sleep 1
    arecord -c 1 -D CssCapture -f S16_LE -r 16000 $1
    killall alsa_test
}

#record_wav /data/media/custom.wav
#startup_wav /data/media/gigaset.wav
startup_wav /data/media/switch_on.wav


