#!/bin/sh

### BEGIN INIT INFO
# Provides:          tftp_swupdate
# Required-Start:    $syslog
# Required-Stop:     $syslog
# Default-Start:     5
# Default-Stop:      0 1 2 3 4 6
# Short-Description: Launches TFTP server required by update procedure
# Description:
### END INIT INFO

. /etc/init.d/init-functions

CONFIG_FILE="/etc/tftp-swupdate.conf"

test -f ${CONFIG_FILE} || { log_warning_msg "${CONFIG_FILE} does not exist, skipping"; exit 1; }

ENABLED=0
PORT=0
source ${CONFIG_FILE}

NAME=tftp-swupdate
DAEMON=/usr/bin/udpsvd
PIDFILE=/var/run/udpsvd.pid
DAEMON_ARGS=" -vE -c 1 0.0.0.0 $PORT tftp-swupdate"

if [ $PORT -eq 0 ]; then
	log_failure_msg "tftp-swupdate port not defined";
	exit 1;
fi

if [ $ENABLED -ne 0 ]; then
    . /etc/init.d/maxwell-functions
fi


