#!/bin/sh

SRC_DIR="/usr/share/vendor/"
DEST_DIR="/vendor"

# Mount gc-vendor

start()
{
  local is_mounted=0
  local readonly=0
  
  
  if [ -e $SRC_DIR/vendor/boot/uImage -a -e $SRC_DIR/vendor/boot/uInitramfs ]; then
    mount | grep vendor > /dev/null && is_mounted=1
    if [ $is_mounted = 0 ]; then
      mkdir -p /vendor
      [ -e /dev/ubi0 ] || ubiattach -m 3 /dev/ubi_ctrl > /dev/null
      mount -t ubifs -o ro,noatime ubi0:vendor /vendor
      [ $? = 0 ] && is_mounted=1
      #mkdir -p $DEST_DIR  
    fi
    
    
    if [ $is_mounted = 1 ]; then
      mount | grep vendor | grep "(ro" > /dev/null && readonly=1

      if [ -d $DEST_DIR ]; then
	[ $readonly = 1 ] && mount -o remount,rw /vendor
	rsync --exclude="variant_*" --exclude="backup" --exclude="factory" --inplace --delete-before -acv $SRC_DIR $DEST_DIR
	sync
	[ $readonly = 1 ] && mount -o remount,ro /vendor
      fi
    fi
  fi
}

stop()
{
  return 0
}


case "$1" in
  start)
        echo -n "Starting gc-vendor sync "
        start
        echo "done"
        ;;
  stop)
        ;;
  restart)
        $0 stop
        $0 start
        ;;
  *)
        echo "Usage: syslog { start | stop | restart }" >&2
        exit 1
        ;;
esac

exit 0
