#!/bin/bash
DESC="initialization of working counter for Quality Assurance"

PATH=/sbin:/bin:/usr/sbin:/usr/bin

PROPCLI="/usr/sbin/propcli"

if [ ! -x ${PROPCLI} ]; then 
    echo "${PROPCLI} binary is missing!"
    exit 1
fi

wait_ipc()
{
    echo -n "Waiting for property service... "
    while [ true ]; do
	${PROPCLI} get System.QA.Startups &>/dev/zero
	EXITCODE="$?"
        if [ ${EXITCODE} -eq 0 ]; then
	    echo
	    break
	fi
#	usleep 200000
	echo -n "."
	COUNTER=$((COUNTER+1))
	if [ ${COUNTER} -gt $1 ]; then
	    echo -e "\nCannot communicate with property service!"
	    exit 1
	fi
    done
}

do_onStart()
{
    wait_ipc 5
    TMP=`${PROPCLI} get System.QA.Startups`
    TMP=$((TMP+1))
    ${PROPCLI} set System.QA.Startups $TMP
    sync
}

do_onSoftReset()
{
    wait_ipc 2
    TMP=`${PROPCLI} get System.QA.SoftReboots`
    TMP=$((TMP+1))
    ${PROPCLI} set System.QA.SoftReboots $TMP
    sync
}

case "$1" in
 start)
	do_onStart
	;;
 stop)
	do_onSoftReset
	;;
 *)
	echo "Usage: $0 [ start | stop ] " >&2
	exit 1
	;;
esac

exit 0
