#!/bin/sh

# only for use as a "zcip" callback script
if [ "x$interface" = x ]
then
	exit 1
fi

# zcip should start on boot/resume and various media changes
case "$1" in
	init)
		# for now, zcip requires the link to be already up,
		# and it drops links when they go down.  that isn't
		# the most robust model...
		exit 0
		;;

	config)
		if [ "x$ip" = x ]
		then
			exit 1
		fi
		ifconfig $interface $ip netmask 255.255.0.0

		propcli set NET.IP.IPv4.Address ${ip} &> /dev/null
		propcli set NET.IP.IPv4.SubnetMask "255.255.0.0" &> /dev/null
		propcli set NET.IP.IPv4.StandardGateway "0.0.0.0" &> /dev/null
		;;

	deconfig)
		if [ x$ip = x ]
		then
			exit 1
		fi
		ifconfig eth0 down
		;;
esac
exit 1
