<?php

class debugManager
{

  public function setDebugLevel($_level)
  {
    /* Bit values:
      NONE_BIT    = 0,
      INFO_BIT    = 1 << 1
      WARNING_BIT = 1 << 2
      ERROR_BIT   = 1 << 3
      TEST_BIT    = 1 << 4
     * */
    $SyslogSeverityMask = "0"; //NONE_BIT
    $SipSeverityMask = "0"; //NONE_BIT

    $nvm = new settingscontroller();
    switch ($_level)
    {
      case 0://max debug level 0 --> disables the output off all messages
        break;
      case 1://max debug level 1 --> enables the "live" output of all syslog messages (Error)
        $SyslogSeverityMask = "8"; //ERROR_BIT
        break;
      case 2://max debug level 2 --> enables the "live" output of all syslog messages (Error, Warning)
        $SyslogSeverityMask = "12"; //ERROR_BIT + WARNING_BIT
        break;
      case 3://max debug level 3 --> enables the "live" output of all syslog messages (Error, Warning,Info)
        $SyslogSeverityMask = "14"; //ERROR_BIT + WARNING_BIT + INFO_BIT
        break;
      case 9://max debug level 9 --> enables the "live" outut off all syslog (all) and SIP messages
        $SyslogSeverityMask = "30"; //ERROR_BIT + WARNING_BIT + INFO_BIT + TEST_BIT
        $SipSeverityMask = "30"; //ERROR_BIT + WARNING_BIT + INFO_BIT + TEST_BIT
        break;
      default:
        return false;
    }
    $req = array();
    //SIP
    $req['DebugLevelMaskSIP'] = $SipSeverityMask;
    //rest of the system
    $req['DebugLevelMaskPCM'] = $SyslogSeverityMask;
    $req['DebugLevelMaskAUDIO'] = $SyslogSeverityMask;
    $req['DebugLevelMaskSYSCONF'] = $SyslogSeverityMask;
    $req['DebugLevelMaskWATCHDOG'] = $SyslogSeverityMask;
    $req['DebugLevelMaskPROP-SRV'] = $SyslogSeverityMask;
    $req['DebugLevelMaskDisplayGUI'] = $SyslogSeverityMask;
    //$req['DebugLevelMaskIPC'] = $SyslogSeverityMask;
    $req['DebugLevelMaskRTP'] = $SyslogSeverityMask;
    $req['DebugLevelMaskMTIMERS'] = $SyslogSeverityMask;

    return $nvm->settingsSaveMultiValue($req);
  }

  public function getLogs($_lastLine, $_lastTimeAccessed)
  {
    $sysLogContent = "";
    $lineNo = 0;
    $lastUpdate = filemtime(SYSLOGPATH);
    if ($lastUpdate != $_lastTimeAccessed)
    {
      $file = fopen(SYSLOGPATH, "r");

      if ($file)
      {
        $fileSize = filesize(SYSLOGPATH);
        if ($_lastLine && $_lastLine < $fileSize)
        {
          fseek($file, $_lastLine, SEEK_SET);
        }
        $sysLogContent = fread($file, $fileSize);
        $lineNo = ftell($file);
        fclose($file);
      }
    }
    return array('syslogAppend' => $sysLogContent, 'lastLine' => $lineNo, 'lastUpdate' => $lastUpdate, '$_lastLine' => $_lastLine, 'since' => $_lastTimeAccessed);
  }

}
