<?php

function POST_Language()
{
  $nvm = new settingscontroller();
  $post = json_decode(file_get_contents('php://input'), true);
  if ($nvm->settingsSaveOneParam('WebUILanguage', $post['value']) == true)
  {
    echo getCodeMess('params', 'savepar', 200);
  }
  else
  {
    echo getCodeMess('params', 'savepar');
  }
}

function POST_CLI()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  switch ($userID)
  {
    case 1://user
      break;
    case 2://admin
      $cliCommand = json_decode(file_get_contents('php://input'));
      //do some parsing here
      $req = array();
      foreach ($cliCommand as $key => $value)
      {
        $req[$key] = $value;
      }
      //verify command
      $str = preg_replace('/\s\s+/', ' ', $req['cmd']);
      if (preg_match("/max debug level [0-39]$/i", $str) !== 1)
      {
        echo getCodeMess('cli', 'cmderr', 400);
        break;
      }

      //extract params
      $params = preg_split("/[\s]+/", $str);

      //exec
      $debugLevel = new debugManager;
      $logLevel = $params[3];
      if ($debugLevel->SetDebugLevel($logLevel) !== true)
      {
        echo getCodeMess('cli', 'cmderr', 400);
      }
      else
      {
        echo getCodeMess('cli', 'cmdok', 200);
      }
      break;
    default:
      echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function POST_Parameters()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $nvm = new settingscontroller();
  $req = array();
  $reqarr = json_decode(file_get_contents('php://input'));
  foreach ($reqarr as $key => $value)
  {
    $req[$key] = $value;
  }
  $nvm->settingsCheckAccessParams($req);

  if ($nvm->settingsSaveMultiValue($req) == true)
  {
    echo getCodeMess('params', 'savepar', 200);
  }
  else
  {
    echo getCodeMess('params', 'savepar');
  }
  $session->closeConnection();
}

function POST_Login()
{

  $session = new sessionmanager();


// obtain the JSON of the body of the request
  $post = json_decode(file_get_contents('php://input'));
  $sessionData = $session->login($post->{'password'});

  if ($sessionData)
  {
    //Admin is Login and user try to log
    if ($sessionData != 3)
    {
      http_response_code(200);
      echo json_encode(array("token" => $sessionData['sessionID'], 'type' => $sessionData['type']));
    }
    else
    {
      echo getCodeMess('session', 'admlog');
    }
  }
  else
  {
    echo getCodeMess('session', 'passerr');
  }

  $session->closeConnection();
}

function POST_Logout()
{
  $session = new sessionmanager();
  $token = GetSessionToken();
  if ($session->logout($token))
  {
    echo getCodeMess('session', 'logout', 200);
  }
  else
  {
    echo getCodeMess('session', 'logout');
  }
  $session->closeConnection();
}

//function POST_Usb()
//{
//  $usb = new usbStick();
//
//  $resp = array();
//  $post = json_decode(file_get_contents('php://input'), true);
//  if ($post['transfer'] == true)
//  {
//    $resp['transferred'] = $usb->mountUSBandCopyFile();
//    http_response_code(200);
//    echo json_encode($resp);
//  }
//}

function POST_State()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == 2)
  {
    $resp = array();
    $post = json_decode(file_get_contents('php://input'), true);
    $nvm = new settingscontroller();

    if ($nvm->settingsSetState($post) == true)
    {
      echo getCodeMess('params', 'savestate', 200);
    }
    else
    {
      echo getCodeMess('params', 'savestate');
    }
  }
  else
  {
    echo getCodeMess('params', 'savestate', 400);
  }
}

function POST_RestoreSettings($_files)
{
  $session = new sessionmanager;

  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $res = new saverestore();
    if ($res->restoreDataFromFile($_files) == true)
    {
      echo getCodeMess('restoresett', 'restoresettings', 200);
    }
    else
    {
      echo getCodeMess('restoresett', 'restoresettings', 400);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_FirmwareUpdate($_files = null)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == 2)
  {
    $upd = new firmwareupdate();
    if (isset($_files))
    {

      if ($upd->SaveFileFromPC($_files) == true)
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate', 200);
      }
      else
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate');
      }
    }
    else
    {
      if ($upd->DownloadFileFromServer() == true)
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate', 200);
      }
      else
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate');
      }
    }
  }
  else
  {
    echo getCodeMess('firmwareupdate', 'firmwareupdate', 400);
  }
}

function POST_SysDump()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == 2)
  {
    $savres = new saverestore();
    if ($savres->makeSysDump() != false)
    {
      return $savres->makeSysDump();
    }
    else
    {
      echo getCodeMess('sysdump', 'sysdump');
    }
  }
  else
  {
    echo getCodeMess('sysdump', 'sysdump', 400);
  }
  $session->closeConnection();
}

function POST_Ringtones($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $ring = new ringtones();
    switch ($ring->uploadRingtones($_files))
    {
      case "#filecount#":
        echo getCodeMess('ringtones', 'filecount');
        break;
      case "#filesize#":
        echo getCodeMess('ringtones', 'filesize');
        break;
      case "#mimetype#":
        echo getCodeMess('ringtones', 'filetype');
        break;
      case "#fileok#":
        break;
      case "#fileerr#":
        http_response_code(500);
        break;
      default:
        http_response_code(500);
        break;
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function POST_Ringtone()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    $ring = new ringtones();
    if (isset($post['delete']))
    {
      if ($ring->deleteRingtones(array(addslashes($post['delete']))) == false)
      {
        http_response_code(500);
      }
    }
    else if (isset($post['deleteAll']))
    {
      if ($ring->deleteAllRingtones() == false)
      {
        http_response_code(500);
      }
    }
    else if (isset($post['play']))
    {
      $ring->playRingtone($post['play'], $post['group']);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function POST_Pin()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    $nvm = new settingscontroller();
    if ($nvm->settingsChangePin(addslashes($post['current']), addslashes($post['new'])))
    {
      http_response_code(200);
    }
    else
    {
      echo getCodeMess('params', 'savepar');
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function POST_Status()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    if (isset($post['alive']) && ($post['alive'] == true))
    {
      $session->updateTimestamp($token);
    }
  }
  else
  {
    echo getCodeMess('session', 'admlog');
  }
  $session->closeConnection();
}

function POST_Certificates($_files)
{

  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID && $userID == 2)
  {
    $cert = new certificates();
    $result = $cert->uploadCertificate($_files);
    switch ($result['action'])
    {
      case "#mimetype#":
        echo getCodeMess('certificates', 'filetype');
        break;
      case "#fileok#":
        echo json_encode(array('file' => $result['filename']));
        break;
      case "#fileerr#":
        echo getCodeMess('certificates', 'filetype');
        break;
      default:
        http_response_code(500);
        break;
    }
  }
  else
  {
    echo getCodeMess('certificates', 'certificates');
  }
}

function POST_UploadXML($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID && $userID == 2)
  {
  $filename = null;
  $down = new filemanager();
  $result = $down->uploadFile($_files, 'fileoperations::replaceFile', array('TypeFilters' => unserialize(XMLMIMETYPE)), array('maxwell' => UPLOADXML), $filename);
  switch ($result)
  {
    case "#mimetype#":
      echo getCodeMess('xml', 'filetype');
      break;
    case "#fileok#":
      http_response_code(200);
      break;
    case "#fileerr#":
      echo getCodeMess('xml', 'filetype');
      break;
    default:
      http_response_code(500);
      break;
  }
  }
  else
  {
      echo getCodeMess('xml', 'xml');
    
  }
}

function POST_UploadImages($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $img = new images();
    switch ($img->uploadImages($_files))
    {
      case "#filecount#":
        echo getCodeMess('images', 'filecount');
        break;
      case "#filesize#":
        echo getCodeMess('images', 'filesize');
        break;
      case "#mimetype#":
        echo getCodeMess('images', 'filetype');
        break;
      case "#fileok#":
        break;
      case "#fileerr#":
        http_response_code(500);
        break;
      default:
        http_response_code(500);
        break;
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function POST_DeleteImages()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    $ring = new images();
    if (isset($post['delete']))
    {
      if ($ring->deleteImages(array(addslashes(WEBUIIMGPATH . DIRECTORY_SEPARATOR . $post['delete']))) == false)
      {
        http_response_code(500);
      }
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

//function DELETE_SipDump()
//{
//  $session = new sessionmanager;
//  $token = GetSessionToken();
//  $userID = $session->verifySession($token);
//  if ($userID && $userID == 2)
//  {
//    if (file_exists(SIPLOGPATH))
//    {
//      if (unlink(SIPLOGPATH))
//      {
//        sendHeader(200, 'File deleted', 0);
//      }
//      else
//      {
//        sendHeader(500, 'File not exists', 0);
//      }
//    }
//    else
//    {
//      sendHeader(404, 'File not exists', 0);
//    }
//  }
//  else
//  {
//    sendHeader(401, 'Bad request', 0);
//  }
//  $session->closeConnection();
//}
