<?php



class Session extends SQLite3
{

  function __construct()
  {
    $this->open('webui.db');
    $this->busyTimeout(10000); //when several php-cgi processes access db, we have to wait untill all locks are removed 
  }

  public function __destruct()
  {
    $this->close();
  }

  //returns session ID or 0 if not allowed
  public function login($user, $password)
  {
    try
    {
      $nvm=NVM::GetInstance();
      $passUser=$nvm->GetValueFromNVM('getV','UserPassword');
      $passAdmin=$nvm->GetValueFromNVM('getV','AdminPassword');
      if(!($password==$passUser) && !($password==$passAdmin))
        return 0;
      
      $sql = "select login, password, accessLevelRead from webui_users where password='" . $password . "'";
      $ret = $this->query($sql);
      if (!$ret)
      {
        loger::LogErr(__FILE__, __LINE__, $this->lastErrorMsg(), $this->lastErrorMsg(), __METHOD__);
        return 0;
      }

      $row = $ret->fetchArray();

      if ($row)
      {
        $user = $row['login'];
        //create session id
        $sessionID = hash("sha256", uniqid(mt_rand(), true));
        $sql = "update webui_users " .
                "set sessionID = '" . $sessionID . "'," .
                "lastAccess=CURRENT_TIMESTAMP" .
                " where login='" . $user . "';";

        if ($this->CanLogin($row['accessLevelRead']) == true && $this->adminislogin() == false)
        {
          if ($this->adminislogin() == true)
          {
            return 3;
          }
          else
          {

            $ret = $this->exec($sql);
            if (!$ret)
            {
              echo $this->lastErrorMsg();
              return 0;
            }

            return array('sessionID' => $sessionID, 'type' => $user);
          }
        }
        else
        {
          if ($this->clearSession() == true)
          {
            return $this->login($user, $password);
          }
          else
          {
            return 3;
          }
        }
      }
      else
      {
        return 0;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return 0;
    }
  }

  private function CanLogin($accessLevel)
  {
    try
    {
      $sql = "select sessionID from webui_users WHERE accessLevelRead='" . $accessLevel . "'";
      $ret = $this->query($sql);
      $resp = $ret->fetchArray();
      if ($resp['sessionID'] != null)
      {
        return false;
      }
      else
      {
        return true;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  public function adminislogin()
  {
    try
    {

      $sql = "select sessionID from webui_users WHERE userID=2";
      $ret = $this->query($sql);
      $resp = $ret->fetchArray();
      if ($resp['sessionID'] != null)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  private function userislogin($session)
  {
    try
    {

      $sql = "select userID from webui_users WHERE sessionID='" . $session . "'";
      $ret = $this->query($sql);
      $resp = $ret->fetchArray();
      if ($resp['userID'] != null)
      {
        return $resp['userID'];
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

 

  public function logout($sessionID)
  {
    try
    {
      $sql = "update webui_users set sessionID = null where sessionID='" . $sessionID . "';";
      $ret = $this->exec($sql);
      if ($ret)
      {
        return 1;
      }
      else
      {
        loger::LogErr(__FILE__, __LINE__, $this->lastErrorMsg(), $this->lastErrorMsg(), __METHOD__);
        return 0;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return 0;
    }
  }

  public function canAccess($userAccess, $resourceName)
  {
    try
    {

      $sql = "SELECT accessLevelRead FROM webui_resources WHERE resourceName='" . $resourceName . "';";
      $ret = $this->query($sql);
      $resp = $ret->fetchArray();
      if ($resp['accessLevel'] <= 2 && $userAccess == 2)
      {
        return true;
      }
      else if ($resp['accessLevel'] < 2 && $userAccess == 1)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  public function validateSession($sessionId)
  {
    if ($this->adminislogin() == true && $this->userislogin($sessionId) == 1)
    {
      return 0;
    }
    else
    {
      return $this->validSession($sessionId);
    }
  }

  private function validSession($_sessionId)
  {
      

    try
    {
      $sql = "select userID,CAST(strftime('%s', CURRENT_TIMESTAMP) as integer) - CAST(strftime('%s',lastAccess) as integer)  as delta from webui_users " .
              "where sessionID='" . $_sessionId . "';";
      $nvm=NVM::GetInstance();
      $logouttime=((int)$nvm->GetValueFromNVM('getV','LogoutTimer')*60)+5;  
      $ret = $this->query($sql);
      if (!$ret)
      {

        echo $this->lastErrorMsg();
        return 0;
      }

      $row = $ret->fetchArray();
      $userId = $row['userID'];
      $delta = $row['delta'];
      //$logtime=intval($nvm->GetValueFromNVM('getV','LogoutTimer'));
      $sql2 = "update webui_users set lastAccess=CURRENT_TIMESTAMP;";
      if ($row && $delta < $logouttime && $this->exec($sql2))
      {
        return $userId;
      }
      else
      {
        $this->logout($_sessionId);
        return 0;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return 0;
    }
  }

  private function clearSession()
  {
    $sql = "select CAST(strftime('%s', CURRENT_TIMESTAMP) as integer) - CAST(strftime('%s',lastAccess) as integer)  as delta from webui_users ";
    $sql2 = "UPDATE webui_users SET sessionID=null";
    $nvm=NVM::GetInstance();
    $ret = $this->query($sql);
    if (!$ret)
    {

      echo $this->lastErrorMsg();
      return false;
    }
    else
    {
      $row = $ret->fetchArray();

      if (abs($row['delta']) > (intval(($nvm->GetValueFromNVM('getV','LogoutTimer'))*60)+5) && $this->exec($sql2))
      {
        return true;
      }
      else
      {
        return false;
      }
    }
  }

  /*
    CREATE TABLE "Webui_Menus" (
    "userId" INTEGER,
    "parentID" INTEGER,
    "itemID" INTEGER PRIMARY KEY,
    "resourceID" INTEGER,
    "textID" INTEGER,
    "order" INTEGER
    );
   */

//$str= file_get_contents("./menu.json");
  public function getUserMenu($userID)
  {
    try
    {
      $menu = array();
//    $submenu = &$menu;
      $submenuRefs = array();
      $sql = "select text, url, parentID, itemID" .
              " from webui_menus," .
              "    webui_texts," .
              "   webui_resources" .
              " where userID=" . $userID .
              " and webui_menus.textID=webui_texts.textID" .
              " and webui_resources.resourceID = webui_menus.resourceID" .
              " order by parentID";

      $ret = $this->query($sql);
      if (!$ret)
      {
        echo $db->lastErrorMsg();
        return 0;
      }
      $submenuRefs[NULL] = &$menu;

      while ($row = $ret->fetchArray())
      {
        $itemID = $row['itemID'];
        $parentID = $row['parentID'];
        if ($parentID === NULL)
        {
          array_push($menu, ["text" => $row['text'], "url" => $row['url']]);
          $submenuRefs[$parentID] = &$menu;
          $submenuRefs[$itemID] = &$menu[count($menu) - 1];
        }
        else
        {
          //if (empty($menu[$parentID]["menu"]))
          if (empty($submenuRefs[$parentID]["menu"]))
          {
            $submenuRefs[$parentID]["menu"] = [];
          }
          array_push($submenuRefs[$parentID]["menu"], ["text" => $row['text'], "url" => $row['url']]);
          $submenuRefs[$itemID] = &$submenuRefs[$parentID]["menu"][count($submenuRefs[$parentID]["menu"]) - 1];
          //array_push($menu,["parentID"=> $row['parentID'],"text"=> $row['text'],"url"=> $row['url']]);
        }
      }
      return $menu;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return 0;
    }
  }

  public function getUserParameters($accessLevel, $resource)
  {

    try
    {
      /* $parameters = array('DeviceNameInNetwork' => 'IP.DeviceNameInNetwork', 'GratuitousARP' => 'IP.GratuitousARP', 'NetworkType' => 'IP.NetworkType', 'IPAddressType' => 'IP.IPAddressType',
        'IPv4Address' => 'IP.IPv4Address', 'IPv4SubnetMask' => 'IP.IPv4SubnetMask', 'IPv4StandardGateway' => 'IP.IPv4StandardGateway', 'IPv4PreferredDNSServer' => 'IP.IPv4PreferredDNSServer',
        'IPv4AlternateDNSServer' => 'IP.IPv4AlternateDNSServer', 'IPv6Address' => 'IP.IPv6Address', 'IPv6PrefixLength' => 'IP.IPv6PrefixLength', 'IPv6PreferredDNSServer' => 'IP.IPv6PreferredDNSServer',
        'IPv6AlternateDNSServer' => 'IP.IPv6AlternateDNSServer'
        ); */
      $parameters = array();
      $sql = "select  parameterName,resourceName " .
              "from webui_paramenters,webui_resourceparameters,webui_resources " .
              "where webui_paramenters.parameterID=webui_resourceparameters.parameterID " .
              "and  webui_resourceparameters.resourceID=webui_resources.resourceID " .
              "and  accessLevelRead<=" . $accessLevel . " and webui_resources.resourceName='" . $resource . "'";
      $ret = $this->query($sql);
      if (!$ret)
      {
        echo $db->lastErrorMsg();
        return 0;
      }

      while ($row = $ret->fetchArray())
      {
        array_push($parameters, $row['parameterName']);
      }

      return $parameters;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return 0;
    }
  }

}

?>