<?php

/**
 * Description of settings
 *
 * @author hampel_ma
 */
class settingscontroller
{

  private $nvm;
  private $view;
  private $state;
  private $nvmresp;

  public function settingscontroller()
  {
    $this->nvm = nvmCore::getInstance();
    $this->view = new viewcontroller();
    $this->state = new tmpsettings();
  }

  /*   * ************ STATE ************* */

  public function settingsSetState($_request)
  {
    $result = $this->state->setState($_request);
    $view = $this->view->creator('viewjson');


    if ($this->view->isViewJsonObject($view))
      $return = $view->viewStateForOneObject($result);
    else
      $return = false;

    return $return;
  }

  public function settingsGetState($_request)
  {
    $result = $this->state->getState($_request);
    $view = $this->view->creator('viewjson');


    if ($this->view->isViewJsonObject($view))
      $return = $view->viewForOneObject($result);
    else
      $return = false;

    return $return;
  }

  /*   * ************ GET PARAMS ************* */

  private function resp($_user)
  {

    $this->nvmresp = $this->view->getAllParamsForUser($_user,'accessLevelRead');
  }

  public function settingsGetAllParams($_user)
  {


    $nvmresp = $this->nvm->getAllValue();

    $view = $this->view->creator('viewjson');



    if ($this->view->isViewJsonObject($view))
    {
      $usertab = $this->resp($_user);

      $nvmrespobj = $this->view->nvmResponseToString($nvmresp);

      $results = array_filter($nvmrespobj->result, function($el) {

        return in_array(explode('.', $el->webui)[0], $this->nvmresp);
      }
      );
      $return = $view->viewGetRequestAllParams($results);
      $return['Timestamp'] = $view->viewGetTimestamp();
    }
    else
      $return = false;
    return $return;
  }

  public function settingsGetMultiValue($_prefix)
  {
    $this->nvm->setRequestForm(array('method' => 'getColsL', 'param' => $_prefix . '%', 'field' => 'webui', 'fields' => 'value,webui,flags,regexp,enum,range_min,range_max'));
    return $this->nvm->makeRequest();
  }

  public function settingsGetArrayValue($_prefix, $_user)
  {
    $this->nvm->setRequestForm(array('method' => 'getColsL', 'param' => $_prefix . '.%', 'field' => 'webui', 'fields' => 'value,webui,flags,regexp,enum,range_min,range_max'));

    $nvmresp = $this->nvm->makeRequest();

    $view = $this->view->creator('viewjson');


    if ($this->view->isViewJsonObject($view))
    {
      $this->resp($_user);
      $nvmrespobj = $this->view->nvmResponseToString($nvmresp);
      $results = array_filter($nvmrespobj->result, function($el) {

        return in_array(explode('.', $el->webui)[0], $this->nvmresp);
      }
      );
      $return = $view->viewGetArrayValue($results);
    }
    else
      $return = false;

    return $return;
  }

  public function settingsGetOneParam($_value)
  {
    $nvmresp = $this->nvm->getOneValue($_value);
    $view = $this->view->creator('viewjson');

    if ($this->view->isViewJsonObject($view))
      $return = $view->viewForOneObject($nvmresp);
    else
      $return = false;

    return $return;
  }

  public function settingsGetTimestamp()
  {
    $tab = array();
    $view = $this->view->creator('viewjson');

    if ($this->view->isViewJsonObject($view))
      $return = $tab['Timestamp'] = $view->viewGetTimestamp();
    else
      $return = false;

    return $return;
  }

  /*   * ************ SAVE PARAMS ************* */

  public function settingsSaveOneParam($_params, $_value)
  {

    if (is_array($_value))
      $_value = implode(',', $_value);

    $this->nvm->setRequestForm(array('method' => 'setV', 'param' => $_params, 'field' => 'webui', 'value' => $_value));
    $nvmresp = $this->nvm->saveValue();

    $view = $this->view->creator('viewjson');

    if ($this->view->isViewJsonObject($view))
      $return = $view->viewSaveOneParam($nvmresp);
    else
      $return = false;

    return $return;
  }

  public function settingsSaveMultiValue($_request)
  {
    
      $_request = $this->settingsCheckAccessParams($_request);
      $queryArray = array();
      $objcount = 0;
      $response = array();


      foreach ($_request as $key => $val)
      {
        //Change number to string
        if (is_numeric($val) || is_bool($val))
          $_request[$key] = (string) $val;

        if ($key == 'Timestamp')
        {
          $this->settingsSetState(array('System.DateAndTime.Timestamp' => $val));
          $sql = new SQLite3('webui.db');
          $sql->exec('update webui_users set lastAccess=CURRENT_TIMESTAMP'); //UPDATE lastAccess when user changed timestamp
          if (count($_request) == 1)
          {
            return true;
          }
        }
        else
        {

          if (is_array($val))
          {

            foreach ($val as $k => $v)
            {
              //Objects with no properties are no longer considered empty.(stdClass())
              if (is_object($v) && $v != new stdClass())
              {

                foreach ($v as $keys => $value)
                {
                  //EXAMPLE JSON {SIP.0.Active:0}
                  $queryArray[$key . '.' . $k . '.' . $keys] = (string) $value;
                }

                $objcount++;
              }
            }
            if ($objcount != 0)
            {

              foreach ($queryArray as $k => $v)
              {
                $response[$k] = $v;
              }
            }
            else
            {
              //Change array to string separated by ,
              $response[$key] = implode(',', $val);
            }
          }
          else
          {
            $response[$key] = (string) $val;
          }
        }
      }


      unset($_request['Timestamp']); // DELETE Timestamp from array
      $this->nvm->setRequestForm(array('method' => 'setVList', 'list' => $response, 'field' => 'webui'));
      $nvmresp = $this->nvm->saveValue();

      $view = $this->view->creator('viewjson');

      if ($this->view->isViewJsonObject($view))
        $return = $view->viewSaveMultiParams($nvmresp);
      else
        $return = false;

      return $return;
  }

  public function settingsCustomRequest($_request)
  {
    $this->nvm->setRequestForm($_request);
    return $this->nvm->makeRequest();
  }

  public function settingsGetText($_key)
  {
    $lang = $this->settingsGetOneParam('WebUILanguage');
    $str = file_get_contents(TEXTPATH . $lang);
    $view = $this->view->creator('viewjson');

    if ($this->view->isViewJsonObject($view))
      $return = $view->viewGetText($str, $_key);
    else
      $return = false;

    echo $return;
  }

  public function settingsCheckAccessParams($_request)
  {
    $view = $this->view->creator('viewjson');

    if ($this->view->isViewJsonObject($view))
    {
      $response = $this->view->userParametersAccessSave($_request);
    }
    else
    {
      $response = false;
    }

    return $response;
  }

  public function settingsChangePin($_currentpin, $_newpin)
  {
    $currpin = $this->settingsGetOneParam('PIN');
    if ($_currentpin == $currpin)
    {
      return $this->settingsSaveOneParam('PIN', $_newpin);
    }
    else
    {
      return false;
    }
  }

  public function settingsSendMessage($_topic, $_message)
  {
    $this->nvm->setRequestForm($_message);
    return $this->nvm->makeMessageRequest($_topic);
  }

}
